Bug 80950 - Styles & Formatting: Add 'Unused Styles' to style filter drop down
Summary: Styles & Formatting: Add 'Unused Styles' to style filter drop down
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsDevEval, topicUI
Depends on:
Blocks: Sidebar-Styles
  Show dependency treegraph
 
Reported: 2014-07-05 15:53 UTC by Hans Deragon
Modified: 2017-08-27 00:13 UTC (History)
12 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Hans Deragon 2014-07-05 15:53:55 UTC
Numerous styles are showing in the style list.  It would be nice if there would be a way to identify those who are not used in the document, so we can delete them afterward.

Ideas for solution:  View menu with radio buttons offering the option "Show all (defaut)", "Used", "Unused".
Comment 1 Luuk 2014-07-05 16:09:00 UTC
One way to find 'Used Styles' is:

Go to 'Styles and Formatting' (F11), and choose 'Applied styles'

This will sow all styles that are used 'somewhere' in the document.

It is not possible to find the location where they are used, which would be a nice enhancement too.....
Comment 2 Cor Nouws 2014-07-05 16:42:41 UTC
Hi Hans,

(In reply to comment #0)
> Numerous styles are showing in the style list.  It would be nice if there
> would be a way to identify those who are not used in the document, ...

The dropdown list Apply styles shows some always by default, and for the rest only those in use. And indeed, also see the answer for Luuk.

IMO a WORKSFORME, OK?
Cheers,
Cor
Comment 3 Cor Nouws 2014-07-05 16:43:32 UTC
(In reply to comment #1)

> It is not possible to find the location where they are used, which would be
> a nice enhancement too.....


Ctrl+H > Options .. find styles (only paragraph styles, that's true - rfe to include character styles does exist.)
Comment 4 Hans Deragon 2014-07-06 13:39:31 UTC
Yes, we have "Applied Styles".  We are missing "Unused styles".  It would be practical to have this to cleanup the list.
Comment 5 Joel Madero 2014-08-04 15:55:57 UTC
REOPENED is reserved for a bug that:

1. a developer has marked as FIXED;
2. a developer is assigned to the bug that is marked as FIXED;

In this case the enhancement request was never independently confirmed so correct status is UNCONFIRMED. Thanks!
Comment 6 Robinson Tryon (qubit) 2015-01-08 08:57:57 UTC
(In reply to Hans Deragon from comment #4)
> Yes, we have "Applied Styles".  We are missing "Unused styles".  It would be
> practical to have this to cleanup the list.

Seems like a reasonable idea for improvement. I don't see any current interface that provides this information.

Status -> NEW

Handing this one over to the UX folks for input on the interface.
Comment 7 Cor Nouws 2015-01-12 12:58:59 UTC
(In reply to Hans Deragon from comment #4)
> Yes, we have "Applied Styles".  We are missing "Unused styles".  It would be
> practical to have this to cleanup the list.

I agree. 
For the implementation it would then be wise if the styles that are not used, but that other styles that are used inherit from, are excluded somehow? Or that on deletion the inheritance is broken.
Comment 8 Robinson Tryon (qubit) 2016-08-25 04:21:37 UTC Comment hidden (obsolete)
Comment 9 Heiko Tietze 2016-09-30 07:31:44 UTC
Removing needsUX and moving to Writer

The overall agreement was that another entry "unused styles" in the dropdown would be useful. Sounds good (at least since it doesn't break anything).
Comment 10 Yousuf Philips (jay) (retired) 2017-05-19 20:15:38 UTC
(In reply to Hans Deragon from comment #0)
> Numerous styles are showing in the style list.  It would be nice if there
> would be a way to identify those who are not used in the document, so we can
> delete them afterward.

As built-in styles arent deletable, the user can only delete user-defined styles, so the entry should only list unused user-defined styles. As we have an entry for 'Custom Styles', so the new entry should be 'Unused Custom Styles'.
Comment 11 Hans Deragon 2017-05-19 20:39:51 UTC
Built-in styles cannot be deleted?  Why is that?

Built-in styles should be treated like user-defined styles; simply added to the list of user-defined style at document creation.  They should not be hardcoded.  They become user-defined styles.

Obviously, that is another issue.  Are you aware of a feature request to change the nature of built-in styles?  I would like to join that debate, if there is one.
Comment 12 Yousuf Philips (jay) (retired) 2017-05-19 22:30:04 UTC
(In reply to Hans Deragon from comment #11)
> Built-in styles cannot be deleted?  Why is that?

As built-in styles arent saved into the document file unless they are used in a document or modified by the users, there isnt a need to be able to delete them, because it would be tedious for users to add them back again.

> Obviously, that is another issue.  Are you aware of a feature request to
> change the nature of built-in styles?  I would like to join that debate, if
> there is one.

I'm not aware of such a request and doubt the ideal would be entertained as all word processors work this way.
Comment 13 Thomas Lendo 2017-05-20 00:45:10 UTC
"Unused styles" should list every not used style of a document, regardless of whether the style is built-in or user created. Styles in that list can be deleted (user styles) or hidden (LibO styles, modified by the user or not) with the context menu. That is was I think Heiko also meant. Only showing user styles (unused custom styles) is half useful and then you would need another entry for pre-defined styles (unused ??? styles) which is an overkill.
Comment 14 Thomas Lendo 2017-05-20 06:53:00 UTC
Please change the summary and delete the "custom" in it. "Unused styles" should be simply the counterpart of "Applied styles" which also doesn't care if styles are created by the user or shipped with LibO. Why should we care need now and add unnecessary complexity?
Comment 15 Heiko Tietze 2017-05-20 22:30:41 UTC
(In reply to Thomas Lendo from comment #13)
> That is was I think Heiko also meant.

You should think about a career as soothsayer :-).
Comment 16 Yousuf Philips (jay) (retired) 2017-05-20 23:31:57 UTC
(In reply to Thomas Lendo from comment #13)
> "Unused styles" should list every not used style of a document, regardless
> of whether the style is built-in or user created. Styles in that list can be
> deleted (user styles) or hidden (LibO styles, modified by the user or not)
> with the context menu.

Yes if there was a 'Unused Styles' entry, it would list both built-in or user created.

> That is was I think Heiko also meant. Only showing
> user styles (unused custom styles) is half useful and then you would need
> another entry for pre-defined styles (unused ??? styles) which is an
> overkill.

If you look at what Hans is asking for in the bug description is the able to delete unused styles from the document, and as you cant delete unused built-in styles a user would want to list of what he/she can delete, which doesnt include built-in styles, aka 'Unused Custom Styles'.

I dont see a point to an 'Unused Styles' list, as every time i open 'Hierarchical' view i pretty much see the same list. :D

@Cor, @Stuart, @Regina, @Sophie: In your view is 'Unused Styles' or 'Unused Custom Styles' more useful?
Comment 17 Thomas Lendo 2017-05-20 23:50:06 UTC
(In reply to Yousuf Philips (jay) from comment #16)
> If you look at what Hans is asking for in the bug description is the able to
> delete unused styles from the document, and as you cant delete unused
> built-in styles a user would want to list of what he/she can delete, which
> doesnt include built-in styles, aka 'Unused Custom Styles'.
I wouldn't take it literally, especially as he didn't know that built-in styles can't be deleted (comment 11). And at the end: it's the same result, hidden or deleted, the unused style isn't visible and that's the point.
Comment 18 Cor Nouws 2017-05-21 13:42:03 UTC
(In reply to Thomas Lendo from comment #17)

> > If you look at what Hans is asking for in the bug description is the able to


@hans@deragon.biz: your turn :)
Comment 19 Hans Deragon 2017-05-24 12:35:19 UTC
As a user, I want to have "unused styles" to show me all styles that are not used by the document.  The reason is that I want to delete them all.  I want a clutter-free style list, with only the styles I use/want.  If I do not use any of the default styles for instance, I do not want to see them when I select "All styles".

If you need to, hide the built-in styles when I 'delete' them.

Applied Styles does not cut it, because their might be unused styles that I could use later on which I would like to see.
Comment 20 V Stuart Foote 2017-05-24 14:25:00 UTC
We could spin this a number of ways. But functionally the built-in styles are immutable and will always be available--even if unused in a document. IIUC our ODF export filters simply do not include built-in style that is not called in the document--while the export filters do include any defined custom styles (used or not). Users need additional tools.

An "Unused Styles" content panel showing _all_ defined styles as a counterpoint to the "Applied Styles" content panel listing, and distinct from "Custom Styles" listing of available template or user defined styles is needed. Main purpose would be to simplify clean-up an ODF compliant document when using template source or if using copied/edited documents.

Believe when working with template source documents--having this feature encourages/supports more efficient use of styles. Allowing the user to clean up prior to publishing.

To implement expect we should organize the content panel to list any "Custom styles" first, and then "Built-in" below, but also provide a GUI option to toggle display of the built-in so as to reduce any perceived clutter. With built-in toggled off--user would be able to select and delete any excess.

Again no issue of deleting the built-ins that can't happen--so this is ultimately just about handling the "customs".
Comment 21 Thomas Lendo 2017-06-14 06:27:05 UTC
I changed the summary from 'Unused custom Styles' to 'Unused Styles' according to the bug opener's statement in comment 19. It's the counterpart to 'Applied Styles'.

If more custom style filters are needed, please add new bugs. Discussions about the possibility to hide/delete built-in styles should be handled in another bug. Also reorganization of the styles list or toggle functionality to show/hide built-in styles should be handled in another bugs.

I added bug 46719 which is handling also unused (custom) styles and has a macro attached.